<?php
/**
 * Module: WHOIS (Domain Details)
 *	- phpCOIN is based on concept and code of Mike Lansberry <mg@mgwebhosting.com>
 *	- whois lookups based loosely on mrwhois Copyright (C) 2001 Marek Rozanski, marek@mrscripts.co.uk
 *	- Do NOT alter or remove this text block
 * @package phpCOIN
 * @subpackage whois
 * @version 1.4
 * @author Stephen M. Kitching <support@phpcoin.com>
 * @copyright Copyright  2003-2008 COINSoftTechnologies Inc. All rights reserved.
 * @license coin_docs/license.txt phpCOIN License Terms
 * @translation lang_whois.php
 * @arguments $ord_domain Domain name to lookup registration details for
 * @arguments @server WHOIS server to ask for the details
 */

# Disable session_auto_start if enabled ~ it screws up logins
	ini_set('session.auto_start', 0);

# Start session
	session_name(md5($_SERVER['SERVER_NAME']));
	session_start();

# Prevent cross-server session stealing
	IF (!isset($_SESSION['hash']) || ($_SESSION['hash'] != md5($_SERVER['SERVER_NAME'].':'.$_SERVER['HTTP_HOST']))) {
		$_SESSION = array();
		IF (isset($_COOKIE[session_name(md5($_SERVER['SERVER_NAME']))])) {setcookie(session_name(md5($_SERVER['SERVER_NAME'])), '', time()-42000, '/');}
		session_destroy();
		session_start();
		$_SESSION['hash'] = md5($_SERVER['SERVER_NAME'].':'.$_SERVER['HTTP_HOST']);
	}

# Turn off pointless "warning" messages, and display errors on-screen
	ini_set('error_reporting','E_ALL & ~E_NOTICE');
	ini_set('display_errors', 'Off');

# Exit with error if php < 4.1
	$_pv = phpversion();
	IF (!version_compare($_pv, '4.1', ">=")) {
		Header("Location: error.php?err=80&required=4.1");
		exit();
	}

# Set our desired "magic_quotes_runtime" if php < v6
	$_pv1 = explode('.', $_pv);
	IF ($_pv1[0] < 6) {set_magic_quotes_runtime(0);}


# Process PHP_SELF variable for XSS before we use it for path building
	while($_SERVER['PHP_SELF'] != urldecode($_SERVER['PHP_SELF'])) {$_SERVER['PHP_SELF'] = urldecode($_SERVER['PHP_SELF']);}
	$_SERVER['PHP_SELF'] = htmlentities($_SERVER['PHP_SELF']);
	IF (function_exists('html_entity_decode')) {
		$_SERVER['PHP_SELF'] = html_entity_decode($_SERVER['PHP_SELF']);
	} ELSE {
		$_SERVER['PHP_SELF'] = unhtmlentities($_SERVER['PHP_SELF']);
	}
	while($_SERVER['PHP_SELF'] != strip_tags($_SERVER['PHP_SELF'])) {$_SERVER['PHP_SELF'] = strip_tags($_SERVER['PHP_SELF']);}
	$pieces = explode("\"",$_SERVER['PHP_SELF']);	$_SERVER['PHP_SELF'] = $pieces[0];
	$pieces = explode("'", $_SERVER['PHP_SELF']);	$_SERVER['PHP_SELF'] = $pieces[0];
	$pieces = explode(" ", $_SERVER['PHP_SELF']);	$_SERVER['PHP_SELF'] = $pieces[0];
	$pieces = explode("\n", $_SERVER['PHP_SELF']);	$_SERVER['PHP_SELF'] = $pieces[0];
	$pieces = explode("\r", $_SERVER['PHP_SELF']);	$_SERVER['PHP_SELF'] = $pieces[0];
	$_tx = substr($_SERVER['PHP_SELF'], -1, 1);
	IF ($_tx == '/') {$_SERVER['PHP_SELF'] = substr($_SERVER['PHP_SELF'], 0, -1);}


# Figure out our location
	$separat			= '/coin_';

# build the file path
	$tempdocroot		= (substr(PHP_OS, 0, 3)=='WIN')?strtolower(getcwd()):getcwd();
	$_PACKAGE['DIR']	= str_replace("\\", '/', $tempdocroot);
	$data_array		= explode("$separat", $_PACKAGE['DIR']);
	$_PACKAGE['DIR']	= $data_array[0].'/';

# Include common session/paths setting file
	IF (is_readable($_PACKAGE['DIR'].'coin_includes/session_common.php')) {
		require($_PACKAGE['DIR'].'coin_includes/session_common.php');
	} ELSE {
		echo 'The required file <b>coin_includes/session_common.php</b> could not be located where it was expected at '.$_PACKAGE['DIR'].'coin_includes/session_common.php';
	}

# Exit if parameters not passed in
	IF (!$_GPV['ord_domain'] || !$_GPV['server']) {exit();}


# Initialize some variables
	$fontface	= 'verdana, ariel, helvetica';
	$fontsize	= 2;
	$stdcolor	= 'black';
	$whois	= str_replace('%ORD_DOMAIN%', $_GPV['ord_domain'], $_GPV['server']);
	$_out	= '<pre>';

# Support .co.za and .mt
	IF (strpos($_GPV['server'], '.co.za') != 0 || strpos($_GPV['server'], '.mt') != 0) {
		$rtn		= ffl_HttpGet($whois, 1);
		$_out	.= $rtn['body'];

# Normal whois lookup
	} ELSE {
		$fp = fsockopen($whois, 43, $errno, $errstr, 10);
		fputs($fp, "$_GPV[ord_domain]\r\n");
		while(!feof($fp)) {$_out .= fgets($fp,128);}
		fclose($fp);
	}


# Display output
	echo '<html><body bgcolor="white"><pre>';
	echo $_out;
	echo '</pre>';
	echo '<p align=center><a href=javascript:window.close()><font face='.$fontface.' size='.$fontsize.' color='.$stdcolor.'><b>Close</b></font></a>';
	echo '</body></html>';


# For php < 4.3 compatability
# replaces html_entity_decode
function unhtmlentities($string) {
	$trans_tbl = get_html_translation_table(HTML_ENTITIES);
	$trans_tbl = array_flip($trans_tbl);
	return strtr($string, $trans_tbl);
}


/**
 * Perform a HTTP Get Request.
 * ffl_HttpGet uses fsockopen() to request a given URL via HTTP
 * 1.0 GET and returns a three element array.  On success, array
 * key 'body' contains the body of the request's reply and key
 * 'header' contains the reply's headers.  On error, the keys
 * returned are 'errornumber' and 'errorstring' from
 * fsockopen()'s third and fourth arguments.  In either case,
 * key 'url' contains an array such as returned from parse_url()
 * after the input url has been massaged a bit.
 * @param string $url URL to fetch.
 * @param boolean $followRedirects Optionally follow
 * 'location:' in header, default true.
 * @return array 'header', 'body', 'url' OR 'errorstring', 'errornumber', 'url'
 */
function ffl_HttpGet($url, $followRedirects=true) {
	$url_parsed = parse_url($url);
	IF (empty($url_parsed['scheme'])) 		{$url_parsed = parse_url('http://'.$url);}
	$rtn['url']						= $url_parsed;

	$port							= $url_parsed['port'];
	IF (!$port)						{$port = 80;}
	IF ($url_parsed['scheme'] == 'https')	{$port = 443;}

	$rtn['url']['port']					= $port;

	$path							= $url_parsed["path"];
	if (empty($path))					{$path = '/';}
	if (!empty($url_parsed["query"]))		{$path .= '?'.$url_parsed['query'];}
	$rtn['url']['path']					= $path;
	$host							= $url_parsed['host'];
	$foundBody						= false;
	$out								= "GET $path HTTP/1.1\r\n";
	$out								.= "Host: $host\r\n";
	$out								.= "Accept: text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5\r\n";
	$out								.= "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7\r\n";
	$out								.= "Connection: keep-alive\r\n";
	$out								.= "\r\n";
	if (!$fp = @fsockopen($host, $port, $errno, $errstr, 10)) {
		$rtn['errornumber'] = $errno;
		$rtn['errorstring'] = $errstr;
		return $rtn;
	}
	fwrite($fp, $out);
	while (!feof($fp)) {
		$s = fgets($fp, 128);
		if ($s == "\r\n") {
			$foundBody = true;
			continue;
		}
		if ($foundBody) {
			$body .= $s;
		} else {
			if (($followRedirects) && (stristr($s, 'location:') != false)) {
				$redirect = preg_replace("/location:/i", '', $s);
				return ffl_HttpGet(trim($redirect));
			}
			$header .= $s;
		}
	}
	fclose($fp);
	$rtn['header']	= trim($header);
	$rtn['body']	= trim($body);
	return $rtn;
}
?>